----============================================ EasyGroupFinder ================================================

local addonName = ...
local EASYGROUPFINDER_VERSION = GetAddOnMetadata(addonName, "Version")
local EASYGROUPFINDER_TITLE = GetAddOnMetadata(addonName, "Title")

----=============================================================================================================

--[[
local function EasyGroupFinder:ChangeSkin()

	if not self.skin_nr or self.skin_nr > 4 then
		self.skin_nr = 0
	end
	
	local backdrop = {
			bgFile = "Interface/Tooltips/UI-Tooltip-Background",
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = true,
			tileSize = 16,
			edgeSize = 16,
			insets = { left = 4, right = 4, top = 4, bottom = 4, }
			}
	
	if self.skin_nr == 0 then
		self:SetBackdrop(backdrop)
		self:SetBackdropColor(0.09, 0.09, 0.19, 0.99)

	elseif self.skin_nr == 1 then
		self:SetBackdrop(backdrop)
		self:SetBackdropColor(0, 0, 0, 1)
		self:SetBackdropBorderColor(0, 0, 0, 0.4)

	elseif self.skin_nr == 2 then
		self:SetBackdrop(backdrop)
		self:SetBackdropColor(0, 0, 0, 0.5)
		self:SetBackdropBorderColor(0, 0, 0, 0.2)
	
	elseif self.skin_nr == 3 then
		backdrop.bgFile = nil
		self:SetBackdrop(backdrop)
		self:SetBackdropBorderColor(0, 0, 0, 0.2)
	
	elseif self.skin_nr == 4 then
		backdrop.bgFile = nil
		backdrop.edgeFile = nil
		self:SetBackdrop(backdrop)

	end
end
]]
--=============================================================================================================

local function zToolz_EJ_SelectLatestTier()
	--EJ_SelectTier(GetExpansionLevel() + 1) -- Select the latest tier
	EJ_SelectTier(EJ_GetNumTiers()) -- Select the latest tier
	if EncounterJournal then
		UIDropDownMenu_SetText(EncounterJournal.instanceSelect.tierDropDown, EJ_GetTierInfo(EJ_GetCurrentTier()))
		EncounterJournal_ListInstances()
	end
end

--=============================================================================================================

local function zToolz_GetMythicDungeonsDoneList()
	RequestRaidInfo()
	local instanceName, _, _, locked, isRaid, maxPlayers, difficultyName
	local completed_list = {}
	local savedInstances = GetNumSavedInstances()
	for i=1, savedInstances do
		instanceName, _, _, _, locked, _, _, isRaid, maxPlayers, difficultyName = GetSavedInstanceInfo(i)
		if string.upper(difficultyName) == "MYTHIC" and locked == true and isRaid == false and maxPlayers == 5 then
			table.insert(completed_list, instanceName)
		end
	end
	return completed_list
end

--=============================================================================================================

local function zToolz_LFGButtonsLoad(catID, btnOffset, isRaid)

	local index, btn, btnName, instanceID, name
	local completed_list = zToolz_GetMythicDungeonsDoneList()

	index = 1
	--index = isRaid and 2 or 1
	instanceID, name = EJ_GetInstanceByIndex(index, isRaid)
	while instanceID do
		name = isRaid and string.gsub(name, "The E", "E") or name -- Remove 'The' from EN raid
		name = isRaid and string.gsub(name, "Broken Isles", "World Bosses (Legion)") or name 
		btnName = "zToolz_Cat" .. catID .. "LFGButton" .. index
		btn = _G[btnName]
		if not btn then
			--print("(" .. catID .. ")  Creating dungeon button: " .. index)
			btn = CreateFrame("Button", btnName, zToolz_LFGButtonsFrame, "UIMenuButtonStretchTemplate") -- "SpellBookSkillLineTabTemplate" "UIMenuButtonStretchTemplate" "UIGoldBorderButtonTemplate" "OptionsButtonTemplate"

--			local backdrop = {
--				bgFile = "Interface\\RaidFrame\\UI-RaidFrame-GroupBg",
--				edgeSize = 16,
--				insets = { left = 4, right = 4, top = 4, bottom = 4 }
--			}

--			local backdrop = {
--				bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
--				tile = true,
--				tileSize = 2,
--				edgeSize = 2,
--				insets = { left = 1, right = 5, top = 5, bottom = 5 }
--			}

--			local backdrop = {
--				bgFile = "Interface\\RaidFrame\\UI-RaidFrame-GroupBg",
--				edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
--				tile = true,
--				tileSize = 32,
--				edgeSize = 9,
--				insets = { left = 4, right = 4, top = 4, bottom = 5 }
--			}

--			btn:SetBackdrop(backdrop)
--			btn:SetBackdropBorderColor(0, 0, 0, 0.5)

			btn:SetPoint("TOPLEFT", 0, -index*24 + btnOffset)
			btn:SetPoint("TOPRIGHT", 0, -index*24 + btnOffset)
			btn:SetFrameStrata("LOW")
			--btn:SetFrameLevel(2)
			btn:SetID(instanceID)
			btn:SetText(name)
			btn:SetSize(145, 26)
			--btn:SetAlpha(0.1)
			--btn.catID = catID
			--btn.Text:Hide()
			btn:GetFontString():SetJustifyH("LEFT")
			btn:GetFontString():SetPoint("LEFT", 15, 0)
			btn:GetFontString():SetPoint("RIGHT", 5, 0)

			--btn:SetNormalFontObject("GameFontNormalLeft")
			--btn.Text:SetFontObject("GameFontNormal")
			--btn:SetScript("OnMouseUp", function() LFGListFrame.SearchPanel.RefreshButton:Click() end)

			btn:RegisterForClicks("AnyUp")
			btn:SetScript("OnClick", 
				function(self, button, down)
					local delay = 0.3
					--PlaySound("igMainMenuOptionCheckBoxOn")
					--print(LFGListFrame.CategorySelection.selectedCategory)
					if catID ~= LFGListFrame.CategorySelection.selectedCategory or not LFGListFrame.SearchPanel:IsShown() then
						print(format("Category changed to: |cff00FF00%s|r", C_LFGList.GetCategoryInfo(catID)))
						GroupFinderFrameGroupButton4:Click()
						LFGListFrame.CategorySelection.CategoryButtons[catID]:Click()
						LFGListFrame.CategorySelection.FindGroupButton:Click()
						delay = 0.5
					end

					local text
					if button == "LeftButton" then
						text = isRaid and " (Normal)" or " (Mythic)"
					elseif button == "RightButton" then
						text = isRaid and " (Heroic)" or " (Mythic Keystone)"
					else
						text = "" --isRaid and " (Mythic)" or ""
					end
					LFGListFrame.SearchPanel.SearchBox:SetText(self:GetText() .. text)
					C_Timer.After(delay, function() LFGListFrame.SearchPanel.RefreshButton:Click() end)
				end
			)

			btn:SetScript("OnEnter", 
				function(self, motion)
					--table.foreach({ self:GetParent():GetChildren() }, function(k, v) v:SetAlpha(1) end)
					self:GetParent():SetAlpha(0.9)
					-- ismodifierkeydown on the raid & dungeon text buttons = show bosses killed in tooltip
					--if IsModifierKeyDown() then
					--	GameTooltip:SetOwner(self, "ANCHOR_RIGHT", 0, - GameTooltip:GetHeight())
					--	GameTooltip:SetInstanceLockEncountersComplete(self:GetID())
					--	GameTooltip:AddDoubleLine("Instance ID", self:GetID(), 0.88, 0.88, 0.1, 0.88, 0.88, 0.1)
					--	GameTooltip:Show()
					--end
				end
			)

			btn:SetScript("OnLeave", 
				function(self, motion)
					--table.foreach({ self:GetParent():GetChildren() }, function(k, v) v:SetAlpha(0.1) end)
					self:GetParent():SetAlpha(0.1)
					--GameTooltip:Hide()
				end
			)

		end

		if tContains(completed_list, name) then
			btn:GetFontString():SetTextColor(0, 1, 0, 0.99)
		else
			btn:GetFontString():SetTextColor(1, 1, 1, 0.99)
		end

		index = index + 1
		instanceID, name = EJ_GetInstanceByIndex(index, isRaid)
	end

end

--=============================================================================================================

local function zToolz_LFGButtonsShow()

	zToolz_EJ_SelectLatestTier()

	-- Dungeon Buttons
	zToolz_LFGButtonsLoad(2, 5, false)

	-- Raid Buttons
--	zToolz_LFGButtonsLoad(3, -300, true)
	zToolz_LFGButtonsLoad(3, -280, true)
end

--=============================================================================================================

local function zToolz_LFGButtonsCreate()

	print(format("%s v%s Loaded", EASYGROUPFINDER_TITLE, EASYGROUPFINDER_VERSION))

	--[[
	print(LFGListFrame.CategorySelection.selectedCategory)
	if LFGListFrame.CategorySelection.selectedCategory == 2 then -- Dungeons
		print("Dungeons")
	elseif LFGListFrame.CategorySelection.selectedCategory == 3 then -- Raids
		print("Raids")
	end
	]]

	-- Create main frame for buttons
	print("Creating: EasyGroupFinder Buttons")
	local zToolz_LFGButtonsFrame = CreateFrame("Frame", "zToolz_LFGButtonsFrame", LFGListFrame)
	zToolz_LFGButtonsFrame:SetAlpha(0.1)
	zToolz_LFGButtonsFrame:SetFrameStrata("LOW")
	--zToolz_LFGButtonsFrame:SetFrameLevel(1)
	zToolz_LFGButtonsFrame:SetSize(145, LFGListFrame:GetHeight())
	zToolz_LFGButtonsFrame:SetPoint("TOPLEFT", LFGListFrame, "TOPRIGHT", -10, 0)
--			zToolz_LFGButtonsFrame:SetBackdrop(GameTooltip:GetBackdrop())
--			zToolz_LFGButtonsFrame:SetBackdropColor(0, 1, 0)
--			zToolz_LFGButtonsFrame:EnableMouse(true)

		zToolz_LFGButtonsFrame:SetScript("OnEnter", 
			function(self, motion)
				--table.foreach({ self:GetChildren() }, function(k, v) v:SetAlpha(1) end)
				--table.foreach({ self:GetChildren() }, function(k, v) v:SetWidth(145) end)
				self:SetAlpha(0.9)
				--btn:SetWidth(145)
				--btn.Text:Show()
			end)

		zToolz_LFGButtonsFrame:SetScript("OnLeave", 
			function(self, motion)
				--table.foreach({ self:GetChildren() }, function(k, v) v:SetAlpha(0.1) end)
				--table.foreach({ self:GetChildren() }, function(k, v) v:SetWidth(20) end)
				self:SetAlpha(0.1)
				--btn:SetWidth(145)
				--btn.Text:Show()
			end)

	-- Button for toggling the Buttons
	local zbtnToggleLFGButtons = CreateFrame("Button", nil, LFGListFrame)
	zbtnToggleLFGButtons:SetSize(28, 28)
	zbtnToggleLFGButtons:SetPoint("TOPRIGHT", LFGListFrame, "TOPRIGHT", -20, 3)
	zbtnToggleLFGButtons:RegisterForClicks("AnyUp")
	zbtnToggleLFGButtons:SetScript("OnClick", 
		function(self, button, down)
			PlaySound("igCharacterInfoTab")
			if button == "LeftButton" then
				zToolz_LFGButtonsFrame:SetShown(not zToolz_LFGButtonsFrame:IsShown())
			else
				if zToolz_LFGButtonsFrame:GetWidth() > 30 then
					zToolz_LFGButtonsFrame:SetWidth(20)
				else
					zToolz_LFGButtonsFrame:SetWidth(145)
				end
			end
		end
	)

	--	local texture = "Interface\\MINIMAP\\TRACKING\\"
	--	zbtnToggleLFGButtons:SetNormalTexture(texture.."Focus")
	--	zbtnToggleLFGButtons:SetPushedTexture(texture.."Target")

		local texture = "Interface\\LFGFRAME\\BattlenetWorking"
		zbtnToggleLFGButtons:SetNormalTexture(texture.."0")
		zbtnToggleLFGButtons:SetPushedTexture(texture.."3") -- or "2"
		--zbtnToggleLFGButtons:SetHighlightTexture(texture.."0")
		zbtnToggleLFGButtons:SetHighlightTexture("Interface\\MINIMAP\\UI-Minimap-Ping-Rotate")
	

	
	--	local zcbtnToggleLFGButtons = CreateFrame("CheckButton", nil, LFGListFrame, "InterfaceOptionsCheckButtonTemplate")
	--	--zcbtnToggleLFGButtons.Text:SetText("Show LFG Buttons")
	--	zcbtnToggleLFGButtons:SetPoint("TOPRIGHT", LFGListFrame, "TOPRIGHT", -145, 1)
	--	zcbtnToggleLFGButtons:SetChecked(true)
	--	zcbtnToggleLFGButtons:SetScript("OnClick", function(self, button, down) zToolz_LFGButtonsFrame:SetShown(self:GetChecked()) end)
			


	GroupFinderFrame:HookScript("OnShow", zToolz_LFGButtonsShow)
		

	--	LFGListFrame.SearchPanel.FilterButton:HookScript("OnMouseDown",
	--		function(self, button)
	--			if button == "RightButton" then
	--				PlaySound("igCharacterInfoTab")
	--				if zToolz_LFGButtonsFrame:GetWidth() > 30 then
	--					zToolz_LFGButtonsFrame:SetWidth(20)
	--				else
	--					zToolz_LFGButtonsFrame:SetWidth(145)
	--				end
	--			end
	--		end
	--	)


end

--=============================================================================================================

C_Timer.After(3, zToolz_LFGButtonsCreate)

--=============================================================================================================

